      SUBROUTINE HYDRO (NROW,NCOL,FLAG,HSIM,H,H1)  
       COMMON /ITCOM/ NR,NC,ISTEP,NPARM,IN,OUT,OUT1,OPT(30),ITER,NSAVE,
     1ISAVE(25),JSAVE(25),KHYD,NCOLS,MCOLS(25),NROWS,MROWS(25) 
     2,IN1,IN2,IN3,IN4,IN5,IN6 
     1,NSTEPS,NBLK,IRWC(4,60),NSPRG,ISPRG(25),JSPRG(25),KSSH,KQUAL
       COMMON /RLCOM/ FMT(20),TITLE(20),DELX(100),DELY(100),PRMITR(10),B
     1(100),G(100),SUMS(18,2), 
     2                              ERROR,PMPFCT,PMPNAM,PERFCT,DELTA,  
     3DELMAJ,E,XLGTNM,FLXNAM(2),FLXFCT 
     1,DELMJ2,TIME,STRFCT,SCALE
     1,TITMOD(20),VFMT(20,7)
       INTEGER OPT,FLAG,OUT,OUT1
       DIMENSION FLAG(NROW,NCOL),HSIM(NROW,NCOL),H(NROW,NCOL),H1(NROW,NC
     1OL),IX(21)
C***********************************************************************
C     THIS SUBROUTINE PRODUCES A HYDROGRAPH FOR SPECIFIED NODES.
C     FOR ARRAYS H AND H1, FIRST SUBSCRIPT INDICATES THE NUMBER OF THE 
C     SPECIFIED NODE AND THE SECOND SUBSCRIPT INDICATES THE TIME PERIOD
C***********************************************************************
      REAL MAP(21) 
      DATA KAT,IX(1),IXX/0,0,1/
      NYR=NSTEPS
      REWIND IN3
      DATA BLANK,SIM,OBS,XINC/1H ,1HS,1HO,5.0/,BOTH/1HB/
      READ (IN3) HSIM  
      IX(1)=1  
      DO 10 K=1,NSAVE  
      I=ISAVE(K)
      J=JSAVE(K)
      H(K,1)=-1.E5 
10    H1(K,1)=HSIM(I,J)
20    NYRS=NYR-20  
C***********************************************************************
      IF (KAT.GT.0.AND.NYRS.LE.-20) RETURN 
C***********************************************************************
      IF(NYRS.LE.0)NYRS=NYR
      NSTOP=0  
      IF(KAT.LT.1)NSTOP=1  
      IF (NYRS.EQ.NYR) GO TO 30
      NYRS=20  
30    CONTINUE 
      NYR=NYR-NYRS 
      DO 60 N=1,NYRS
      IK=IXX+N 
      READ (IN3) HSIM  
      NSTOP=NSTOP+1
      READ (IN3) IOPT  
      IX(IK)=IOPT  
      DO 40 K=1,NSAVE  
      I=ISAVE(K)
      J=JSAVE(K)
40    H(K,IK)=HSIM(I,J)
      IF (IOPT.LT.1) GO TO 60  
      NSTOP=NSTOP+1
      READ (IN3) HSIM  
      DO 50 K=1,NSAVE  
      I=ISAVE(K)
      J=JSAVE(K)
50    H1(K,IK)=HSIM(I,J)
60    CONTINUE 
      KAT=KAT+1
      IF (KAT.GT.1) GO TO 70
      IXY=0
      NYRS=NYRS+1  
70    DO 140 N=1,NSAVE 
      II=ISAVE(N)  
       WRITE(OUT,170)TITMOD,TITLE  
      JJ=JSAVE(N)  
      IYX=NYRS-IXX+(KAT-1)*20  
      WRITE (OUT,150) II,JJ,(J,J=IXY,IYX)  
      HMAX=-1.E10  
      DO 80 K=1,NYRS
      IOPT=IX(K)
      IF(IOPT.GT.0)HMAX=AMAX1(HMAX,H1(N,K))
80    HMAX=AMAX1(HMAX,H(N,K))  
      HMAX=HMAX+2.0*XINC
      KOUNT=0  
      JOUNT=0  
90    DO 100 J=1,21
100   MAP(J)=BLANK 
      JOUNT=JOUNT+1
      HMAX=HMAX-XINC
      DO 120 L=1,NYRS  
      IOPT=IX(L)
      IF (ABS(H(N,L)-HMAX).GE.(XINC*0.5)) GO TO 110
      KOUNT=KOUNT+1
      MAP(L)=SIM
      IF (IOPT.LT.1) GO TO 120 
      IF (ABS(H1(N,L)-HMAX).GE.(XINC*0.5)) GO TO 110
      KOUNT=KOUNT+1
      MAP(L)=BOTH  
      GO TO 120
110   CONTINUE 
      IF (IOPT.LT.1) GO TO 120 
      IF (ABS(H1(N,L)-HMAX).GE.(XINC*0.5)) GO TO 120
      KOUNT=KOUNT+1
      MAP(L)=OBS
120   CONTINUE 
130   CONTINUE 
      WRITE (OUT,160) HMAX,MAP 
      IF (KOUNT.GE.NSTOP.OR.JOUNT.GT.50) GO TO 140 
      GO TO 90 
140   CONTINUE 
      IXX=0
      IXY=KAT*20+1 
      GO TO 20 
C  
C  
C  
C  
150   FORMAT (1H0,10X,'HYDROGRAPH FOR NODE (',I3,1H,,I3,1H),10X,'S=SIMUL
     1ATED',5X,'O=OBSERVED',5X,'B=OBSERVED=SIMULATED'//5X,'HEAD',11X,21I
     25/)  
160   FORMAT (1H ,F10.3,12X,21(1X,A4)) 
  170 FORMAT(1H1,T25,20A4//T25,20A4/)  
      END  
