       SUBROUTINE SOLVE(NROW,NCOL,FLAG,H,HO,T,SF1,Q,R,RD,TOPAQ)
C***********************************************************************0  
C     THIS ROUTINE SOLVES FOR HEADS USING THE IADI PROCEDURE
C***********************************************************************0  
       COMMON /ITCOM/ NR,NC,ISTEP,NPARM,IN,OUT,OUT1,OPT(30),ITER,NSAVE,
     1ISAVE(25),JSAVE(25),KHYD,NCOLS,MCOLS(25),NROWS,MROWS(25) 
     2,IN1,IN2,IN3,IN4,IN5,IN6 
     1,NSTEPS,NBLK,IRWC(4,60),NSPRG,ISPRG(25),JSPRG(25),KSSH,KQUAL
       COMMON /RLCOM/ FMT(20),TITLE(20),DELX(100),DELY(100),  PARM(10),B
     1(100),G(100),SUMS(18,2), 
     2                              ERROR,PMPFCT,PMPNAM,PERFCT,DELTA,  
     3DELMAJ,E,XLGTNM,FLXNAM(2),FLXFCT 
     1,DELMJ2,TIME,STRFCT,SCALE
     1,TITMOD(20),VFMT(20,7)
       INTEGER OPT,FLAG,OUT,OUT1
       DIMENSION H(NROW,NCOL),HO(NROW,NCOL),T(NROW,NCOL,2),SF1(NROW,NCOL
     1),Q(NROW,NCOL) ,FLAG(NROW,NCOL)  
     1,RD(NROW,NCOL),R(NROW,NCOL)  
     1,TOPAQ(NROW,NCOL)
        DOUBLE PRECISION BB,CC,W
      ITER=0
10    CONTINUE 
      ITER=ITER+1  
      IF (ITER.GT.50) GO TO 380
      K=MOD(ITER,NPARM)+1  
      PK=PARM(K)
      E=0.0
C***********************************************************************1410
C     ROW CALCULATIONS                                                  1510
C***********************************************************************1610
      DO 190 II=1,NR
      I=II 
      IF(MOD(ISTEP+ITER,2).EQ.1)I=NR-I+1
      EE=1.
      IF(I.EQ.1)EE=0.0 
      JSTRT=1  
20    DO 30 JJ=JSTRT,NC
      IFL=FLAG(I,JJ)+1 
      GO TO (30,40,40,30), IFL 
30    CONTINUE 
      GO TO 190
40    CONTINUE 
      JJP1=JJ+1
50    DO 60 JJJ=JJP1,NC
      IFL=FLAG(I,JJJ)+1
      GO TO (70,60,60,70), IFL 
60    CONTINUE 
      JJJ=NC
      JSTRT=NC 
      GO TO 80 
70    JJJ=JJJ-1
      JSTRT=JJJ+1  
80    CONTINUE 
      AA=0.
      DD=0.
      BB=0.
      IF (JJ.EQ.1) GO TO 90
      IF (FLAG(I,JJ-1).GT.0) GO TO 90  
      BB=T(I,JJ-1,1)
      DD=BB*H(I,JJ-1)  
90    CONTINUE 
      DO 150 J=JJ,JJJ  
      TT=-AA
      BB=BB+TT 
100   TT=T(I,J,1)  
      CC=-TT
      BB=BB+TT 
      IF(FLAG(I,J+1).EQ.0)DD=DD+TT*H(I,J+1)
110   TT=T(I-1,J,2)*EE 
      BB=BB+TT 
      DD=DD+TT*H(I-1,J)
120   TT=T(I,J,2)  
      BB=BB+TT 
      DD=DD+TT*H(I+1,J)
      DD=DD+BB*PK*H(I,J)
      BB=BB*(1.+PK)
130    RAT=1.  
       IFL=FLAG(I,J)+1 
       IF(IFL.EQ.2.AND.H(I,J).GT.TOPAQ(I,J)) RAT=1./STRFCT 
       IF(IFL.EQ.3.AND.H(I,J).LT.TOPAQ(I,J)) RAT=STRFCT
       DD=DD-Q(I,J)+SF1(I,J)/DELTA*(HO(I,J)-TOPAQ(I,J)*(1.-RAT))
       BB=BB+SF1(I,J)/DELTA*RAT
       HA=R(I,J)
       IF(HA) 135,140,131  
131    IF(H(I,J)-RD(I,J))140,140,132
132    BB=BB+HA
       DD=DD+HA*RD(I,J)
       GO TO 140
135    BB=BB-HA
       DD=DD-HA*RD(I,J)
140   W=BB-AA*B(J-1)
      B(J)=CC/W
      G(J)=(DD-AA*G(J-1))/W
      DD=0.
      BB=0.
150   AA=-T(I,J,1) 
C***********************************************************************6710
C     RE-ESTIMATE HEADS                                                 6810
C***********************************************************************6910
      E=E+ABS(H(I,JJJ)-G(JJJ)) 
      H(I,JJJ)=G(JJJ)  
      N=JJJ
160   N=N-1
      IF (N-JJ+1) 180,180,170  
170   HA=G(N)-B(N)*H(I,N+1)
      E=E+ABS(HA-H(I,N))
      H(I,N)=HA
      GO TO 160
180   IF (JSTRT-NC) 20,190,190 
190   CONTINUE 
C***********************************************************************8110
C     COLUMN CALCULATIONS                                               8210
C***********************************************************************8310
      DO 370 JJ=1,NC
      J=JJ 
      IF(MOD(ISTEP+ITER,2).EQ.1)J=NC-J+1
      EE=1.
      IF(J.EQ.1)EE=0.  
      ISTRT=1  
200   DO 210 II=ISTRT,NR
      IFL=FLAG(II,J)+1 
      GO TO (210,220,220,210), IFL 
210   CONTINUE 
      GO TO 370
220   CONTINUE 
      IIP1=II+1
230   DO 240 III=IIP1,NR
      IFL=FLAG(III,J)+1
      GO TO (250,240,240,250), IFL 
240   CONTINUE 
      III=NR
      ISTRT=NR 
      GO TO 260
250   III=III-1
      ISTRT=III+1  
260   CONTINUE 
      AA=0.
      DD=0.
      BB=0.
      IF (II.EQ.1) GO TO 270
      IF (FLAG(II-1,J).GT.0) GO TO 270 
      BB=T(II-1,J,2)
      DD=BB*H(II-1,J)  
270   CONTINUE 
      DO 330 I=II,III  
280   TT=T(I,J-1,1)*EE 
      BB=BB+TT 
      DD=DD+TT*H(I,J-1)
290   TT=T(I,J,1)  
      BB=BB+TT 
      DD=DD+TT*H(I,J+1)
      TT=-AA
      BB=BB+TT 
300   TT=T(I,J,2)  
      BB=BB+TT 
      CC=-TT
      IF(FLAG(I+1,J).EQ.0)DD=DD+TT*H(I+1,J)
      DD=DD+BB*PK*H(I,J)
      BB=BB*(1.+PK)
310    RAT=1.  
       IFL=FLAG(I,J)+1 
       IF(IFL.EQ.2.AND.H(I,J).GT.TOPAQ(I,J)) RAT=1./STRFCT 
       IF(IFL.EQ.3.AND.H(I,J).LT.TOPAQ(I,J)) RAT=STRFCT
       DD=DD-Q(I,J)+SF1(I,J)/DELTA*(HO(I,J)-TOPAQ(I,J)*(1.-RAT))
       BB=BB+SF1(I,J)/DELTA*RAT
       HA=R(I,J)
       IF(HA)315,320,311
311    IF(H(I,J)-RD(I,J)) 320,320,312  
312    BB=BB+HA
       DD=DD+HA*RD(I,J)
       GO TO 320
315    DD=DD-HA*RD(I,J)
       BB=BB-HA
320   W=BB-AA*B(I-1)
      B(I)=CC/W
      G(I)=(DD-AA*G(I-1))/W
      DD=0.
      BB=0.
330   AA=-T(I,J,2) 
C***********************************************************************
C     RE-ESTIMATE HEADS                                                 
C***********************************************************************
      E=E+ABS(H(III,J)-G(III)) 
      H(III,J)=G(III)  
      N=III
340   N=N-1
      IF (N-II+1) 360,360,350  
350   HA=G(N)-B(N)*H(N+1,J)
      E=E+ABS(H(N,J)-HA)
      H(N,J)=HA
      GO TO 340
360   IF (ISTRT-NR) 200,370,370
370   CONTINUE 
      IF (E.GT.ERROR) GO TO 10 
      IF (ITER.LT.4) GO TO 10  
380   RETURN
      END  
