      SUBROUTINE XSECT (NROW,NCOL,FLAG,HSIM,HOBS,BOTLEL)
C***********************************************************************
C     THIS SUBROUTINE PRODUCES A PRINTER PLOT OF CROSS-SECTIONS ALONG  
C     ROWS OR COLUMNS.  MAXIMUM NUMBER OF ROWS OR COLUMNS IS 100.  
C***********************************************************************
      INTEGER IDUM(10) 
      DATA IDUM/1,2,3,4,5,6,7,8,9,0/
      COMMON /ITCOM/ NR,NC,ISTEP,NPARM,IN,OUT,OUT1,OPT(30),ITER,NSAVE, 
     1ISAVE(25),JSAVE(25),KHYD,NCOLS,MCOLS(25),NROWS,MROWS(25) 
     2,IN1,IN2,IN3,IN4,IN5,IN6 
     1,NSTEPS,NBLK,IRWC(4,60),NSPRG,ISPRG(25),JSPRG(25),KSSH,KQUAL
      COMMON /RLCOM/ FMT(20),TITLE(20),DELX(100),DELY(100),PRMITR(10),B
     1(100),G(100),SUMS(18,2), 
     2                              ERROR,PMPFCT,PMPNAM,PERFCT,DELTA,  
     3DELMAJ,E,XLGTNM,FLXNAM(2),FLXFCT 
     1,DELMJ2,TIME,STRFCT,SCALE
     1,TITMOD(20),VFMT(20,7)
      INTEGER OPT,FLAG,OUT,OUT1
      DIMENSION HSIM(NROW,NCOL),HOBS(NROW,NCOL),PLOT(100), 
     1FLAG(NROW,NCOL)  
     2,BOTLEL(NROW,NCOL)
     1,XINTGR(10)  
      DATA XINTGR/1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H0/ 
      EQUIVALENCE (PLOT(1),B(1))
      DATA SIM,OBS,BLANK,BOTH/1HS,1HO,1H ,1HB/ 
      DIMENSION XCOL(2)
      DATA XROW/3HROW/,XCOL/4HCOLU,2HMN/
      IOPT=OPT(22) 
      DO 220 L=1,NCOLS 
      IF (NCOLS.LT.1) GO TO 220
      ORIGX=0  
      IF(SCALE.GT.0.) GO TO 20 
      DO 10 I=1,NR 
   10 G(I)=I
      JST=1
      J=NR+1
      GO TO 60 
   20 G(1)=0
      DO 30 I=2,NR 
   30 G(I)=G(I-1)+(DELY(I)+DELY(I-1))/2.
      JST=1
      IF(G(NR)/SCALE.GT.50.) GO TO 450 
   40 DO 50 J=JST,NR
      IF((G(J)-ORIGX).GT.9.9*SCALE) GO TO 60
   50 CONTINUE 
      J=NR+1
   60 JEND=J-1 
      GSAVE=G(JEND)
      IF(JST.EQ.JEND.AND.JST.NE.NR) GO TO 230  
      WRITE(OUT,540)TITMOD,TITLE,ISTEP 
      J=MCOLS(L)
      WRITE (OUT,470) J
      WRITE (OUT,550)  
      IF(SCALE.LE.1.E-3) GO TO 80  
      DO 70 I=JST,JEND 
      K=(G(I)+SCALE/20.-ORIGX) /(SCALE/10.)+1  
   70 G(I)=K+0.5
   80 WRITE (OUT,570) XROW 
      DO 110 LL=1,2
      DO 90 K=1,100
   90 PLOT(K)=BLANK
      DO 100 I=JST,JEND
      KG=G(I)  
      KL=I/10  
      PLOT(KG)=XINTGR(KL)  
      IF(KL.EQ.0) PLOT(KG)=BLANK
      IF(LL.EQ.1) GO TO 100
      KL=MOD(I,10) 
      IF(KL.EQ.0) KL=10
      PLOT(KG)=XINTGR(KL)  
  100 CONTINUE 
  110 WRITE (OUT,520) PLOT 
      HMAX=-1.E5
      HMIN=1.E5
      DO 120 I=1,NR
      IF (FLAG(I,J).GT.2) GO TO 120
      HA=HSIM(I,J) 
      IF(IOPT.GT.0.AND.ABS(HOBS(I,J)).GE.1.E-3) HA=HOBS(I,J)
      HB=HA
      IF(FLAG(I,J).EQ.1) HB=BOTLEL(I,J)
      HMAX=AMAX1(HMAX,HSIM(I,J),HA,HB) 
      HMIN=AMIN1(HMIN,HSIM(I,J),HA,HB) 
  120 CONTINUE 
      HMAX=IFIX(HMAX+1.)
      HMIN=IFIX(HMIN-1.)
      XINC=(HMAX-HMIN)/40. 
      XINC=FLOAT(IFIX((XINC+0.5)*2.))/2.0  
      XXINC=XINC*0.5
      DO 180 LL=1,41
      DO 130 I=1,100
  130 PLOT(I)=BLANK
      DO 160 I=JST,JEND
      KG=G(I)  
      IF (FLAG(I,J).GT.2) GO TO 160
      IF(ABS(BOTLEL(I,J)-HMAX).LE.XXINC) PLOT(KG)=1H+  
      IF(ABS(HSIM(I,J)-HMAX).LE.XXINC) PLOT(KG)=SIM
      IF (IOPT.LT.1) GO TO 160 
      IF (ABS(HOBS(I,J)-HMAX).LE.XXINC) GO TO 140  
      GO TO 160
  140 IF(PLOT(KG).EQ.SIM) GO TO 150
      PLOT(KG)=OBS 
      GO TO 160
  150 PLOT(KG)=BOTH
  160 CONTINUE 
  170 WRITE (OUT,510) HMAX,PLOT
      HMAX=HMAX-XINC
  180 CONTINUE 
      WRITE (OUT,570) XROW 
      DO 210 LL=1,2
      DO 190 K=1,100
  190 PLOT(K)=BLANK
      DO 200 I=JST,JEND
      KG=G(I)  
      KL=I/10  
      PLOT(KG)=XINTGR(KL)  
      IF(KL.EQ.0) PLOT(KG)=BLANK
      IF(LL.EQ.1) GO TO 200
      KL=MOD(I,10) 
      IF(KL.EQ.0) KL=10
      PLOT(KG)=XINTGR(KL)  
  200 CONTINUE 
  210 WRITE (OUT,520) PLOT 
      JST=JEND 
      ORIGX=GSAVE  
      G(JST)=GSAVE 
      IF(JST.LT.NR) GO TO 40
  220 CONTINUE 
  230 CONTINUE 
      DO 440 L=1,NROWS 
      IF (NROWS.LT.1) GO TO 440
      ORIGX=0  
      IF(SCALE.GT.0) GO TO 250 
      DO 240 J=1,NC
  240 G(J)=J
      JST=1
      J=NC+1
      GO TO 290
  250 G(1)=0
      DO 260 J=2,NC
  260 G(J)=G(J-1)+(DELX(J)+DELX(J-1))/2.
      JST=1
      IF(G(NC)/SCALE.GT.50.) GO TO 450 
  270 DO 280 J=JST,NC  
      IF((G(J)-ORIGX).GT.9.9*SCALE) GO TO 290  
  280 CONTINUE 
      J=NR+1
  290 JEND=J-1 
      GSAVE=G(JEND)
      IF(JST.EQ.JEND.AND.JST.NE.NC) GO TO 460  
      WRITE(OUT,540)TITMOD,TITLE,ISTEP 
      I=MROWS(L)
      WRITE (OUT,530) I
      WRITE (OUT,550)  
      IF(SCALE.LE.1.E-3) GO TO 310 
      DO 300 J=JST,JEND
      K=(G(J)+SCALE/20. -ORIGX)/(SCALE/10.)+1  
  300 G(J)=K+0.5
  310 CONTINUE 
      WRITE (OUT,570) XCOL 
      DO 340 LL=1,2
      DO 320 K=1,100
  320 PLOT(K)=BLANK
      DO 330 J=JST,JEND
      KG=G(J)  
      KL=J/10  
      PLOT(KG)=XINTGR(KL)  
      IF(KL.EQ.0) PLOT(KG)=BLANK
      IF(LL.EQ.1) GO TO 330
      KL=MOD(J,10) 
      IF(KL.EQ.0) KL=10
      PLOT(KG)=XINTGR(KL)  
  330 CONTINUE 
  340 WRITE(OUT,520) PLOT  
      HMAX=-1.E5
      HMIN=1.E5
      DO 350 J=JST,JEND
      IF (FLAG(I,J).GT.2) GO TO 350
      HA=HSIM(I,J) 
      IF(IOPT.GT.0.AND.ABS(HOBS(I,J)).GE.1.E-3) HA=HOBS(I,J)
      HB=HA
      IF(FLAG(I,J).EQ.1) HB=BOTLEL(I,J)
      HMAX=AMAX1(HMAX,HSIM(I,J),HA,HB) 
      HMIN=AMIN1(HMIN,HSIM(I,J),HA,HB) 
  350 CONTINUE 
      HMAX=IFIX(HMAX+1.)
      HMIN=IFIX(HMIN-1.)
      XINC=(HMAX-HMIN)/40. 
      XINC=FLOAT(IFIX((XINC+0.5)*2.))/2.0  
      XXINC=XINC*0.5
      DO 400 LL=1,41
      DO 360 J=1,100
  360 PLOT(J)=BLANK
      DO 390 J=JST,JEND
      KG=G(J)  
      IF (FLAG(I,J).GT.2) GO TO 390
      IF(ABS(BOTLEL(I,J)-HMAX).LE.XXINC) PLOT(KG)=1H+  
      IF(ABS(HSIM(I,J)-HMAX).LE.XXINC) PLOT(KG)=SIM
      IF (IOPT.LT.1) GO TO 390 
      IF (ABS(HOBS(I,J)-HMAX).LE.XXINC) GO TO 370  
      GO TO 390
  370 IF(PLOT(KG).EQ.SIM) GO T O 380
      PLOT(KG)=OBS 
      GO TO 390
  380 PLOT(KG)=BOTH
  390 CONTINUE 
      WRITE (OUT,510) HMAX,PLOT
      HMAX=HMAX-XINC
  400 CONTINUE 
      WRITE (OUT,570) XCOL 
      DO 430 LL=1,2
      DO 410 K=1,100
  410 PLOT(K)=BLANK
      DO 420 J=JST,JEND
      KG=G(J)  
      KL=J/10  
      PLOT(KG)=XINTGR(KL)  
      IF(KL.EQ.0) PLOT(KG)=BLANK
      IF(LL.EQ.1) GO TO  420
      KL=MOD(J,10) 
      IF(KL.EQ.0) KL=10
      PLOT(KG)=XINTGR(KL)  
  420 CONTINUE 
  430 WRITE (OUT,520) PLOT 
      JST=JEND 
      ORIGX=GSAVE  
      G(JST)=GSAVE 
      IF(JST.LT.NC) GO TO 270  
  440 CONTINUE 
      RETURN
  450 WRITE (OUT,580)  
  460 RETURN
C***********************************************************************
C  
C  
C  
C  
  470 FORMAT (25H0CROSS-SECTION FOR COLUMN,I3) 
  480 FORMAT (1H0,24X,100I1)
  490 FORMAT (16X,100I1)
  500 FORMAT (7X,'HEAD',5X,100I1)  
  510 FORMAT (1X,F10.2,5X,100A1)
  520 FORMAT (T17,100A1)
  530 FORMAT (22H0CROSS-SECTION FOR ROW,I3)
  540 FORMAT(1H1,T25,20A4//T25,20A4/T54,'FOR TIME STEP',I5//)  
  550 FORMAT (1H+,T40,'S=SIMULATED',5X,'O=OBSERVED',5X,'B=OBSERVED=SIMUL
     1ATED',5X,'+=BASE')
  560 FORMAT (1H+,15X,2A4) 
  570 FORMAT (1H0,T17,2A4) 
  580 FORMAT (' SCALE INCORRECT  PLOT TERMINATED'//)
      END  
