      SUBROUTINE PHYSDT(NROW,NCOL,FLAG,BOTLEL,H,HO,P,SF1,T,THIK,SURF,  
     1TOPAQ,R,RD) 
      COMMON /ITCOM/ NR,NC,ISTEP,NPARM,IN,OUT,OUT1,OPT(30),ITER,NSAVE, 
     1ISAVE(25),JSAVE(25),KHYD,NCOLS,MCOLS(25),NROWS,MROWS(25) 
     2,IN1,IN2,IN3,IN4,IN5,IN6 
     1,NSTEPS,NBLK,IRWC(4,60),NSPRG,ISPRG(25),JSPRG(25)
     1,KSSH,KQUAL  
      COMMON /RLCOM/ FMT(20),TITLE(20),DELX(100),DELY(100),PRMITR(10),B
     1(100),G(100),SUMS(18,2), 
     2                              ERROR,PMPFCT,PMPNAM,PERFCT,DELTA,  
     3DELMAJ,E,XLGTNM,FLXNAM(2),FLXFCT 
     1,DELMJ2,TIME,STRFCT,SCALE,TITMOD(20),VFMT(20,7)  
      INTEGER OPT,FLAG,OUT,OUT1
      DIMENSION FLAG(NROW,NCOL),H(NROW,NCOL),BOTLEL(NROW,NCOL),HO(NROW,
     1NCOL),P(NROW,NCOL,2),SF1(NROW,NCOL),T(NROW,NCOL,2),THIK(NROW,NCOL)
     2,SURF(NROW,NCOL),TOPAQ(NROW,NCOL)
     1,R(NROW,NCOL),RD(NROW,NCOL)  
      DIMENSION TYPE(2,4)  
      DATA TYPE/4HWATR,4H TBL,4HARTE,4HSIAN,4HBOUN,
     14HDARY,4HCONS,4HT HD/
C***********************************************************************
C     READ OPTIONS WHICH CONTROL GENERAL EXECUTION OF PROGRAM  
C***********************************************************************
      READ (IN,630) OPT
      DO 10 I=1,20 
      IF (OPT(I).GT.0) WRITE (OUT,590) I,OPT(I)
   10 CONTINUE 
      KSSH=OPT(14) 
      KQUAL=OPT(15)
C***********************************************************************
C     IF HYDROGRAPHS ARE REQUIRED, READ NUMBER OF AND COORDINATES OF
C     THE SPECIFIC NODES.  
C***********************************************************************
      IF (OPT(1).LT.1) GO TO 20
      KHYD=OPT(1)  
      READ (IN,660) NSAVE,(ISAVE(I),JSAVE(I),I=1,NSAVE)
   20 CONTINUE 
C***********************************************************************
C     IF CROSS-SECTIONS ARE REQUESTED, READ NUMBER OF AND INDEX FOR THE
C     REQUESTED COLUMNS AND ROWS, RESPECTIVELY.
C***********************************************************************
      IF (OPT(2).LT.1) GO TO 30
      READ (IN,660) NCOLS,(MCOLS(I),I=1,NCOLS) 
      READ (IN,660) NROWS,(MROWS(I),I=1,NROWS) 
   30 CONTINUE 
C***********************************************************************
C     READ GRID SPACINGS IN THE X AND Y DIMENSIONS, RESPECTIVELY.  
C***********************************************************************
      DO 40 K=1,20 
   40 FMT(K)=VFMT(K,1) 
      IF(OPT(3).LT.5) GO TO 50 
      OPT(3)=OPT(3)-5  
      READ (IN,670) FMT
      WRITE (OUT,740) (FMT(K),K=1,10)  
   50 IF(OPT(3).LT.1) GO TO 80 
C***********************************************************************
C     READ AND WRITE CONSTANT GRID SPACINGS
C***********************************************************************
      READ (IN,FMT) HA,HB  
      DO 60 I=1,NR 
   60 DELY(I)=HB
      DO 70 J=1,NC 
   70 DELX(J)=HA
      WRITE (OUT,730) HA,HB
      GO TO 90 
   80 CONTINUE 
      READ (IN,FMT) (DELX(J),J=1,NC)
      READ (IN,FMT) (DELY(I),I=1,NR)
      IF (OPT(4).LT.1) GO TO 90
      WRITE (OUT,690)  
      WRITE (OUT,600) (DELX(J),J=1,NC) 
      WRITE (OUT,700)  
      WRITE (OUT,600) (DELY(I),I=1,NR) 
   90 CONTINUE 
      IF(SCALE.GT.-1.E-3) GO TO 120
      SCALE=1.E6
      DO 100 I=1,NR
  100 SCALE=AMIN1(DELY(I)*6.,SCALE)
      DO 110 J=1,NC
  110 SCALE=AMIN1(DELX(J)*10.,SCALE)
  120 WRITE (OUT,610) SCALE,XLGTNM 
C***********************************************************************
C     READ PHYSICAL DATA FORMAT CARD
C***********************************************************************
      DO 130 K=1,20
  130 FMT(K)=VFMT(K,2) 
      IF(OPT(5).LT.5) GO TO 140
      OPT(5)=OPT(5)-5  
      READ (IN,670) FMT
      WRITE (OUT,740) (FMT(K),K=1,10)  
  140 IF(OPT(5).LT.1) GO TO 160
C***********************************************************************
C     READ AND WRITE DEFAULT VALUES TO BE ASSIGNED TO ALL NODES
C***********************************************************************
      READ (IN,FMT) K,(B(N),N=1,8) 
      IF(K.EQ.2) B(8)=B(8)/1.E6
      WRITE (OUT,720) K,(B(N),N=1,8)
      DO 150 J=1,NC
      DO 150 I=1,NR
      FLAG(I,J)=K  
      SURF(I,J)=B(1)
      TOPAQ(I,J)=B(2)  
      BOTLEL(I,J)=B(3) 
      THIK(I,J)=B(4)
      H(I,J)=B(5)  
      P(I,J,1)=B(6)
      P(I,J,2)=B(7)
  150 SF1(I,J)=B(8)
      GO TO 180
  160 CONTINUE 
C***********************************************************************
C     READ NODE CARDS 
C***********************************************************************
      DO 170 I=1,NR
      DO 170 J=1,NC
      READ (IN,FMT) FLAG(I,J),SURF(I,J),TOPAQ(I,J),BOTLEL(I,J),THIK(I,J
     1),H(I,J),P(I,J,1),P(I,J,2),SF1(I,J)  
      IF(FLAG(I,J).EQ.2) SF1(I,J)=SF1(I,J)/1.E6
  170 CONTINUE 
  180 CONTINUE 
      IF (OPT(6).LT.1) GO TO 230
      DO 190 K=1,20
  190 FMT(K)=VFMT(K,3) 
      IF(OPT(6).LT.5) GO TO 200
      READ (IN,670) FMT
C***********************************************************************
C      READ CORRECTIONS TO NODE CARDS  
C***********************************************************************
      WRITE (OUT,740) (FMT(K),K=1,10)  
  200 WRITE(OUT,710)
      WRITE (OUT,640)  
  210 READ (IN,FMT) II,III,JJ,JJJ,K,(B(N),N=1,8)
      IF(II.LT.1) GO TO 230
      IF(K.EQ.2) B(8)=B(8)/1.E6
      IF(K.EQ.0)K=4
      DO 220 I=II,III  
      DO 220 J=JJ,JJJ  
      FLAG(I,J)=K  
      IF(K.GT.3) FLAG(I,J)=0
      WRITE (OUT,650) TYPE(1,K),TYPE(2,K),I,J,FLAG(I,J),(B(N),N=1,8)
      SURF(I,J)=B(1)
      TOPAQ(I,J)=B(2)  
      BOTLEL(I,J)=B(3) 
      THIK(I,J)=B(4)
      H(I,J)=B(5)  
      P(I,J,1)=B(6)
      P(I,J,2)=B(7)
  220 SF1(I,J)=B(8)
      GO TO 210
  230 CONTINUE 
C***********************************************************************
C      READ PARAMETER ADJUSTMENT DATA 
C***********************************************************************
      IF(OPT(7).GT.0) CALL CALIB(NROW,NCOL,FLAG,P,SF1,THIK,BOTLEL,H,OPT
     1(7)) 
      DO 320 K=1,2 
      IF(K.EQ.1.AND.OPT(11).LT.1) GO TO 320
      IF(K.EQ.2.AND.OPT(12).LT.1) GO TO 320
      IFL=OPT(11)  
      IF(K.EQ.2) IFL=OPT(12)
      IFL5=IFL 
      IF(IFL.GT.5) IFL=IFL-5
C***********************************************************************
C      READ LEAKAGE TERMS  
C***********************************************************************
      IF(K.EQ.1) WRITE (OUT,750)
      IF(K.EQ.2) WRITE ( OUT,760)  
      IF(IFL.GT.2) GO TO 270
      DO 240 N=1,20
  240 FMT(N)=VFMT(N,4) 
      IF(IFL5.LT.5) GO TO 250  
      READ (IN,670) FMT
      WRITE (OUT,740) (FMT(N),N=1,10)  
  250 DO 260 I=1,NR
      READ (IN,FMT) (B(J),G(J),J=1,NC) 
      DO 260 J=1,NC
      R(I,J)=R(I,J)*G(J)
      IF(K.EQ.1) R(I,J)=G(J)
      RD(I,J)=RD(I,J)*B(J) 
  260 IF(K.EQ.1) RD(I,J)=B(J)  
      IF(IFL.EQ.1) GO TO 320
  270 DO 280 N=1,20
  280 FMT(N)=VFMT(N,5) 
      IF(IFL5.LT.5) GO TO 290  
      READ (IN,670) FMT
      WRITE (OUT,740) (FMT(I),I=1,10)  
  290 WRITE (OUT,770)  
  300 READ (IN,FMT) II,III,JJ,JJJ,HA,HB
      IF(II.LT.1) GO TO 320
      WRITE (OUT,780) II,III,JJ,JJJ,HA,HB  
      DO 310 I=II,III  
      DO 310 J=JJ,JJJ  
      R(I,J)=R(I,J)*HB 
      IF(K.EQ.1) R(I,J)=HB 
      RD(I,J)=RD(I,J)*HA
  310 IF(K.EQ.1) RD(I,J)=HA
      GO TO 300
  320 CONTINUE 
C***********************************************************************
C      WRITE LEAKAGE TERMS 
C***********************************************************************
      IF(OPT(13).LT.1) GO TO 350
      WRITE(OUT,680)TITMOD,TITLE
      WRITE (OUT,790) XLGTNM
      DO 330 I=1,NR
  330 WRITE (OUT,570) I,(RD(I,J),J=1,NC)
      WRITE(OUT,680)TITMOD,TITLE
      WRITE (OUT,800) PMPNAM,XLGTNM
      DO 340 I=1,NR
      WRITE (OUT,570) I,(R(I,J),J=1,NC)
  340 CONTINUE 
  350 CONTINUE 
      DO 360 I=1,NR
      DO 360 J=1,NC
      IF(FLAG(I,J).LT.1) R(I,J)=0.0
      IF(R(I,J)) 358,360,359
358   R(I,J)=R(I,J)*DELX(J)*DELY(I)
      GO TO 360
359   R(I,J)=-R(I,J)*PMPFCT
360   CONTINUE 
C***********************************************************************
C      READ SPRING OR RIVER CELL DATA  
C***********************************************************************
      IF(NSPRG.LT.1) GO TO 410 
      READ(IN,670)FMT
      DO 370 N=1,20
  370 FMT(N)=VFMT(N,6) 
      WRITE(OUT,785)
      WRITE(OUT,740)(FMT(K),K=1,10)
      DO 400 N=1,NSPRG 
      IF(NSPRG.LT.1) GO TO 400 
      READ (IN,FMT) I,J,RD(I,J),R(I,J) 
      HA=-R(I,J)
      IF(HA.GT.0.0) GO TO 380  
      WRITE (OUT,850) I,J,RD(I,J),R(I,J)
     1,PMPNAM,XLGTNM
      GO TO 390
  380 WRITE (OUT,860) I,J,RD(I,J),HA
     1,PMPNAM,XLGTNM
  390 R(I,J)=R(I,J)*PMPFCT 
      ISPRG(N)=I
  400 JSPRG(N)=J
  410 CONTINUE 
      IF (KHYD.LT.1) GO TO 420 
C***********************************************************************
C     SAVE ORIGINAL HEADS FOR HYDROGRAPH ROUTINE
C***********************************************************************
      REWIND IN3
      WRITE(IN3)H
  420 CONTINUE 
C***********************************************************************
C      SAVE INITIAL WATER LEVELS
C***********************************************************************
      REWIND IN1
      WRITE(11)H
C***********************************************************************
C      CHECK INPUT DATA
C***********************************************************************
      DO 470 I=1,NR
      DO 470 J=1,NC
      IF(FLAG(I,J).GT.2) GO TO 470 
      IF(H(I,J).GT.BOTLEL(I,J)) GO TO 430  
      H(I,J)=BOTLEL(I,J)+0.1
      WRITE( OUT,810) I,J,H(I,J)
  430 IF(TOPAQ(I,J).LE.SURF(I,J)) GO TO 440
      TOPAQ(I,J)=SURF(I,J) 
      WRITE (OUT,820) I,J,TOPAQ(I,J)
  440 IF(FLAG(I,J).EQ.1) GO TO 450 
      IF(FLAG(I,J).LT.1) GO TO 450 
      IF(H(I,J).GT.TOPAQ(I,J)) GO TO 460
      FLAG(I,J)=1  
        SF1(I,J)=SF1(I,J)*STRFCT
      WRITE (OUT,830) I,J  
      GO TO 460
  450 IF(H(I,J).LE.TOPAQ(I,J)) GO TO 460
      IF(FLAG(I,J).LT.1) GO TO 460 
      FLAG(I,J)=2  
        SF1(I,J)=SF1(I,J)/STRFCT
      WRITE (OUT,840) I,J  
  460 CONTINUE 
  470 CONTINUE 
C***********************************************************************
C      ZERO PERMEABILITIES FOR BOUNDARY CELLS  
C***********************************************************************
      DO 490 I=1,NR
      DO 490 J=1,NC
      IF(FLAG(I,J).EQ.3) P(I,J,1)=0.0  
      IF(FLAG(I,J).EQ.3) P(I,J,2)=0.0  
      IF(I.EQ.NR) GO TO 480
      IF(FLAG(I+1,J).EQ.3) P(I,J,2)=0.0
      IF(FLAG(I,J).EQ.0.AND.FLAG(I+1,J).EQ.0) P(I,J,2)=0.0 
  480 IF(J.EQ.NC) GO TO 490
      IF(FLAG(I,J+1).EQ.3) P(I,J,1)=0.0
      IF(FLAG(I,J).EQ.0.AND.FLAG(I,J+1).EQ.0) P(I,J,1)=0.0 
  490 CONTINUE 
C***********************************************************************
C     WRITE PHYSICAL PARAMETERS
C***********************************************************************
      IF (OPT(8).LT.1) GO TO 510
      DO 500 I=1,NR
      WRITE(OUT,680)TITMOD,TITLE
      WRITE (OUT,640)  
      DO 500 J=1,NC
      IFLG=FLAG(I,J)
      IF(IFLG.EQ.0)IFLG=4  
      WRITE (OUT,650) TYPE(1,IFLG),TYPE(2,IFLG),I,J,FLAG(I,J), 
     1SURF(I,J),TOPAQ(I,J),BOTLEL(I,J),THIK(I,J),H(I,J),P(I,J,1),  
     2P(I,J,2),SF1(I,J)
  500 CONTINUE 
  510 CONTINUE 
C***********************************************************************
C      CONVERT UNITS
C***********************************************************************
      DO 520 I=1,NR
      DO 520 J=1,NC
      P(I,J,1)=P(I,J,1)*PERFCT 
      P(I,J,2)=P(I,J,2)*PERFCT 
      IF(KSSH.GT.0) SF1(I,J)=0.0
  520 SF1(I,J)=SF1(I,J)*DELX(J)*DELY(I)
C***********************************************************************
C      PLOT INITIAL WATER LEVELS
C***********************************************************************
      IF(OPT(9).GT.0) CALL PLOTH(NROW,NCOL,FLAG,H,THIK,TOPAQ,BOTLEL,SF1
     1,1)  
C***********************************************************************
C      LIST AND PLOT INITIAL SATURATED THICKNESS
C***********************************************************************
      IF(OPT(10).EQ.3) GO TO 550
      IF (OPT(10).LT.1) GO TO 560  
      WRITE(OUT,680)TITMOD,TITLE
      WRITE (OUT,580)  
      DO 540 I=1,NR
      DO 530 J=1,NC
      HO(I,J)=THIK(I,J)
  530 IF(FLAG(I,J).EQ.1) HO(I,J)=H(I,J)-BOTLEL(I,J)
  540 WRITE (OUT,570) I,(HO(I,J),J=1,NC)
      IF(OPT(10).LT.2) GO TO 560
  550 CALL PLOTH(NROW,NCOL,FLAG,H,THIK,TOPAQ,BOTLEL,SF1,2) 
  560 CONTINUE 
C***********************************************************************
C      RETURN  
C***********************************************************************
      RETURN
C***********************************************************************
C  
C  
C  
C  
  570 FORMAT (/I5,10F10.3/(5X,10F10.3))
  580 FORMAT (T5,'INITIAL SATURATED THICKNESS'/)
  590 FORMAT (T20,'GENERAL PROGRAM OPTION',I5,' EQUALS',I5)
  600 FORMAT (5X,10F10.1)  
  610 FORMAT (/T20,'PLOT SCALE =',F12.3,1X,A6,' PER INCH'/)
  620 FORMAT (1H1) 
  630 FORMAT (35I1)
  640 FORMAT (1H0,T4,'NODE',T12,'ROW',T18,'COL',T24,'FLAG',T33,'SURFACE
     1',T45,'TOP OF',T54,'BOTTOM',T65,'THIK-',T75,'WATER',T85,'PERM',  
     2T95,'PERM',T103,'STORAGE'/T4,'TYPE',T32,'ELEVATION',T44,'AQUIFER',
     1T53,'ELEVATION',T65,'NESS',T75,'LEVEL',T85,'X-DIR',T95,'Y-DIR',  
     4T104,'COEF'/1X,28(4H----))
  650 FORMAT (1X,2A4,I4,2I6,5X,5F10.2,2F10.0,E10.4)
  660 FORMAT (26I3)
  670 FORMAT (20A4)
  680 FORMAT(1H1,T25,20A4//T25,20A4/)  
  690 FORMAT (1H0,'DISTANCE SPACINGS IN X-DIRECTION')  
  700 FORMAT (1H0,'DISTANCE SPACINGS IN Y-DIRECTION')  
  710 FORMAT (1H0,T30,'NODE CORRECTIONS',//)
  720 FORMAT (1H0,T25,'DEFAULT VALUES'//T25,'NODE TYPE',T55,I5/
     2T25,'LAND SURFACE',T50,F10.2/T25,'TOP OF AQUIFER',T50,F10.2/ 
     3T25,'BASE OF AQUIFER',T50,F10.2/T25,'SATURATED THICKNESS',T50,
     5F10.2/T25,'WATER LEVEL',T50,F10.2/T25,'PERMEABILITY(1)-X',T50,F10.
     62/T25,'PERMEABILITY(2)-Y',T50,F10.2/T25,'STORAGE COEFFICIENT',T50,
     7F10.6//) 
  730 FORMAT (1H0,T20,'CONSTANT GRID SPACINGS'/T20,'DEL X =',F10.3,5X,'D
     1EL Y =',F10.3/)  
  740 FORMAT (T70,'FORMAT IS',T80,10A4/)
  750 FORMAT (T20,'LEAKAGE TERMS ASSIGNMENT')  
  760 FORMAT (T20,'LEAKAGE TERM ADJUSTMENT')
  770 FORMAT (T20,'ROW',T30,'ROW',T40,'COLUMN',T50,'COLUMN',T72,'REF.',
     2T86,'SLOPE'/T20,'START',T30,'END',T40,'START',T50,'END',T72,'HEAD'
     2//)  
  780 FORMAT (T20,I3,T30,I3,T43,I3,T53,I3,T70,F10.0,T85,F10.1) 
785    FORMAT(1H0,T20,'SPRING AND RIVER CELL DATA')
  790 FORMAT (T20,'REFERENCE HEADS ',A6//) 
  800 FORMAT (T20,'SLOPES ',A6,'/',A6,'/STEP'//)
  810 FORMAT (T20,'FOR NODE',I3,',',I3,' HEAD BELOW BASE.  NEW HEAD =',
     2F10.3)
  820 FORMAT (T20,'FOR NODE',I3,',',I3,' TOP OF AQUIFER ABOVE LAND SURF
     3ACE. NEW TOP =',F10.3)
  830 FORMAT (T20,'FOR NODE',I3,',',I3,' CHANGED TO WATER TABLE')  
  840 FORMAT (T20,'FOR NODE',I3,',',I3,' CHANGED TO ARTESIAN') 
  850 FORMAT (T20,'NODE',2I3,' IS SPRING. REFERENCE HEAD =',F10.3,' SLO
     1PE =',F10.0,1X,A6,'/',A6,'/STEP')
  860 FORMAT (T20,'NODE',2I3,' IS RIVER. REFERENCE HEAD =',F10.3,  
     1' SLOPE =',F10.0,1X,A6,'/',A6,'/STEP')
      END  
