      SUBROUTINE PLOTH(NROW,NCOL,FLAG,H,THIK,TOPAQ,BOTLEL,SF1,ICD) 
C***********************************************************************
C     THIS SUBROUTINE PRODUCES A SYMBOLIC MAP OF VARIOUS PARAMETERS.
C     MAXIMUM NUMBER OF COLUMNS IS 100.
C      ICD=1 HEAD MAP  
C      ICD=2 SATURATED THICKNESS MAP
C      ICD=3 QUALITY MAP
C***********************************************************************
      COMMON /ITCOM/ NR,NC,ISTEP,NPARM,IN,OUT,OUT1,OPT(30),ITER,NSAVE, 
     1ISAVE(25),JSAVE(25),KHYD,NCOLS,MCOLS(25),NROWS,MROWS(25) 
     2,IN1,IN2,IN3,IN4,IN5,IN6 
     1,NSTEPS,NBLK,IRWC(4,60),NSPRG,ISPRG(25),JSPRG(25),KSSH,KQUAL
      COMMON /RLCOM/ FMT(20),TITLE(20),DELX(100),DELY(100),PRMITR(10),B
     1(100),G(100),SUMSS(18,2),
     2                              ERROR,PMPFCT,PMPNAM,PERFCT,DELTA,  
     3DELMAJ,E,XLGTNM,FLXNAM(2),FLXFCT 
     1,DELMJ2,TIME,STRFCT,SCALE
     1,TITMOD(20),VFMT(20,7)
      INTEGER OPT,FLAG,OUT,OUT1
      DIMENSION IFREQ(26),SYMBOL(26),XRANGE(27),PLOTS(100),
     1PERCT(26),H(NROW,NCOL),TOPAQ(NROW,NCOL),BOTLEL(NROW,NCOL)
     1,SF1(NROW,NCOL) ,FLAG(NROW,NCOL) ,THIK(NROW,NCOL)
     1,TOT(26),TOT1(26),TOT2(26)
     1,XINTGR(10)  
      DATA XINTGR/1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H0/ 
C***********************************************************************
C     XINCRE EQUALS THE RANGE FOR EACH PRINTER SYMBOL  
C***********************************************************************
      DATA XINCRE,BLANK,IFIRST/10.0,4H    ,0/  
      DATA SYMBOL/1HA,1HB,1HC,1HD,1HE,1HF,1HG,1HH,1HI,1HJ,1HK,1HL, 
     11HM,1HN,1HO,1HP,1HQ,1HR,1HS,1HT,1HU,1HV,1HW,1HX,1HY,1HZ/ 
      DIMENSION IDUM(10)
      DATA IDUM/1,2,3,4,5,6,7,8,9,0/
      DIMENSION XROW(3), XCOL(2)
      DATA XROW/1HR,1HO,1HW/,XCOL/4HCOLU,4HMN  /
      ENTRY QPLOTH (NROW,NCOL,FLAG,H,QTITLE,ICD)
      DIMENSION QTITLE(20) 
      HA=0 
      HB=-1.E-6
      HC=1.E6  
      M=0  
      DO 20 I=1,NR 
      DO 20 J=1,NC 
      IF(FLAG(I,J).GT.2) GO TO 20  
      IF(FLAG(I,J).EQ.0) GO TO 20  
      M=M+1
      HD=H(I,J)
      IF(ICD.NE.2) GO TO 10
      HD=THIK(I,J) 
      IF(FLAG(I,J).EQ.1) HD=H(I,J)-BOTLEL(I,J) 
   10 HA=HA+HD 
      HB=AMAX1(HB,HD)  
      HC=AMIN1(HC,HD)  
   20 CONTINUE 
      HA=HA/M  
      ERR=HC
      HB=(HB-HC)/26
      HC=0.1
      IF(HB.GT.0.1) HC=1.  
      IF(HB.GT.1.) HC=5.
      IF(HB.GT.5.) HC=10.  
      IF(HB.GT.10.) HC=25. 
      IF(HB.GT.25.) HC=50. 
      IF(HB.GT.50.) HC=100.
      HA=IFIX(HA/HC)*HC
      HB=IFIX(ERR/HC)*HC
      XRANGE(1)=-1.E6  
      XRANGE(27)=1.E6  
      ERR=HA-HC*12 
      XRANGE(2)=AMAX1(ERR,HB)  
      DO 30 I=3,26 
   30 XRANGE(I)=XRANGE(2)+HC*(I-2) 
      ORIGX=0. 
      IF(SCALE.GT.0.) GO TO 50 
      DO 40 J=1,NC 
   40 G(J)=J
      JST=1
      J=NC+1
      GO TO 100
   50 CONTINUE 
      B(1)=0
      DO 60 I=2,NR 
   60 B(I)=B(I-1)+(DELY(I)+DELY(I-1))/2.
      G(1)=0.  
      DO 70 J=2,NC 
   70 G(J)=G(J-1)+(DELX(J)+DELX(J-1))/2.
      JST=1
      IF(G(NC)/SCALE.GT.50.) GO TO 310 
      IF(B(NR)/SCALE.GT.50.) GO TO 310 
   80 DO 90 J=JST,NC
      IF((G(J)-ORIGX).GT.9.9*SCALE) GO TO 100  
   90 CONTINUE 
      J=NC+1
  100 JEND=J-1 
      GSAVE=G(JEND)
      IF(JST.EQ.JEND.AND.JST.NE.NC) GO TO 310  
      WRITE(OUT,540)TITMOD,TITLE
      IF(ICD.EQ.3) WRITE (OUT,550) QTITLE  
      IF(ICD.EQ.1) WRITE (OUT,460) ISTEP
      IF(ICD.EQ.2) WRITE(OUT,470) ISTEP
      IF(ICD.EQ.3) WRITE (OUT,480) ISTEP
      WRITE (OUT,640)  
      IF(SCALE.LE.1.E-3) GO TO 120 
      DO 110 J=JST,JEND
      K=(G(J)+SCALE/20.-ORIGX)/(SCALE/10.)+1
  110 G(J)=K+0.5
  120 WRITE (OUT,670)  XCOL
      DO 150 L=1,2 
      DO 130 K=1,100
  130 PLOTS(K)=BLANK
      DO 140 J=JST,JEND
      KG=G(J)  
      KL=J/10  
      PLOTS(KG)=XINTGR(KL) 
      IF(KL.EQ.0) PLOTS(KG)=BLANK  
      IF(L.EQ.1) GO TO 140 
      KL=MOD(J,10) 
      IF(KL.EQ.0) KL=10
      PLOTS(KG)=XINTGR(KL) 
  140 CONTINUE 
  150 WRITE (OUT,660) PLOTS
      WRITE (OUT,630)  
      WRITE (OUT,680)  
      YDIS=B(1)
      DO 270 I=1,NR
      DO 160 K=1,100
  160 PLOTS(K)=BLANK
      DO 230 J=JST,JEND
      KG=G(J)  
      IFL=FLAG(I,J)+1  
      GO TO (170,180,180,230),IFL  
  170 PLOTS(KG)=1H*
      GO TO 230
  180 ERR=H(I,J)
      IF(ICD.NE.2) GO TO 190
      ERR=THIK(I,J)
      IF(FLAG(I,J).EQ.1) ERR=H(I,J)-BOTLEL(I,J)
  190 CONTINUE 
      DO 200 KK=2,26
      IF(ERR.LT.XRANGE(KK)) GO TO 210  
  200 CONTINUE 
      IERR=26  
      GO TO 220
  210 IERR=KK-1
  220 PLOTS(KG)=SYMBOL(IERR)
  230 CONTINUE 
      IF(SCALE.LT.1.) GO TO 260
      KK=0 
      IF(I.EQ.1) GO TO 260 
      IF(I.EQ.NR) GO TO 240
      IF((B(I+1)-YDIS).LT.SCALE/12.)GOTO  270  
  240 KK=(B(I)-YDIS)/(SCALE/6.) +.5
      DO 250 KL=1,KK
      IF(KK.LT.1) GO TO 250
      WRITE (OUT,650)  
  250 CONTINUE 
  260 WRITE (OUT,620) I,PLOTS  
      YDIS=YDIS+SCALE/6.*(KK+1)
  270 CONTINUE 
      WRITE (OUT,630)  
      WRITE (OUT,670) XCOL 
      DO 300 L=1,2 
      DO 280 K=1,100
  280 PLOTS(K)=BLANK
      DO 290 J=JST,JEND
      KG=G(J)  
      KL=J/10  
      PLOTS(KG)=XINTGR(KL) 
      IF(KL.EQ.0) PLOTS(KG)=BLANK  
      IF(L.EQ.1) GO TO 290 
      KL=MOD(J,10) 
      IF(KL.EQ.0) KL=10
      PLOTS(KG)=XINTGR(KL) 
  290 CONTINUE 
  300 WRITE (OUT,660) PLOTS
      JST=JEND 
      ORIGX=GSAVE  
      G(JST)=GSAVE 
      IF(JST.LT.NC) GO TO 80
      GO TO 320
  310 WRITE (OUT,690)  
  320 CONTINUE 
      XNODE=0  
      DO 330 I=1,26
      TOT(I)=0.
      TOT1(I)=0.
      TOT2(I)=0.
  330 IFREQ(I)=0.  
      DO 420 I=1,NR
      DO 410 J=1,NC
      IFL=FLAG(I,J)+1  
      GO TO (410,340,340,410),IFL  
  340 ERR=H(I,J)
      IF(ICD.NE.2) GO TO 350
      ERR=THIK(I,J)
      IF(FLAG(I,J).EQ.1) ERR=H(I,J)-BOTLEL(I,J)
  350 CONTINUE 
      XNODE=XNODE+1.
      DO 360 KK=2,26
      IF(ERR.LT.XRANGE(KK)) GO TO 370  
  360 CONTINUE 
      IERR=26  
      GO TO 380
  370 IERR=KK-1
  380 IFREQ(IERR)=IFREQ(IERR)+1
      TOT1(IERR)=TOT1(IERR)+DELX(J)*DELY(I)
      IF(ICD.NE.2) GO TO 410
      IF(FLAG(I,J).EQ.2) GO TO 390 
      TOT(IERR)=TOT(IERR)+SF1(I,J)*(H(I,J)-BOTLEL(I,J))
      GO TO 400
  390 TOT2(IERR)=TOT2(IERR)+SF1(I,J)*(H(I,J)- TOPAQ(I,J))  
      TOT(IERR)=TOT(IERR)+SF1(I,J)*STRFCT*THIK(I,J)
  400 CONTINUE 
  410 CONTINUE 
  420 CONTINUE 
      PERCT(1)=FLOAT(IFREQ(1))/XNODE*100.  
      DO 430 I=2,26
  430 PERCT(I)=FLOAT(IFREQ(I))/XNODE*100.+PERCT(I-1)
      WRITE (OUT,490)  
      TOT4=0.  
      TOT5=0.  
      TOT3=0.  
      IF (ICD.EQ.2) WRITE (OUT,610) XLGTNM,XLGTNM  
     1,XLGTNM  
      WRITE (OUT,600)  
      DO 440 I=1,26
      WRITE (OUT,510) SYMBOL(I),XRANGE(I),XRANGE(I+1),IFREQ(I),PERCT(I)
      IF(ICD.EQ.2) WRITE (OUT,580) TOT1(I),TOT(I),TOT2(I)  
      TOT4=TOT4+TOT2(I)
      TOT3=TOT3+TOT1(I)
  440 TOT5=TOT5+TOT(I) 
      WRITE (OUT,450)  
      IF(ICD.EQ.2) WRITE (OUT,590) TOT3,TOT5,TOT4  
C***********************************************************************
      RETURN
C  
C  
C  
C  
  450 FORMAT (4X,'*',8X,'CONSTANT HEAD'/)  
  460 FORMAT (T5,'HEADS AT END OF TIME STEP',I5)
  470 FORMAT (T5,'SATURATED THICKNESS AT END OF TIME STEP',I5) 
  480 FORMAT (T5,'QUALITY VALUES AT END OF TIME STEP',I5/) 
  490 FORMAT (1H0,T25,'FREQUENCY DISTRIBUTION',//,' SYMBOL',12X,9HRANGE(
     1FT),12X,'FREQUENCY',5X,' PER CENT .LE.') 
  500 FORMAT (5H MEAN,19X,F10.5,/19H STANDARD DEVIATION,5X,F10.5)  
  510 FORMAT (1H ,3X,A1,8X,F8.3,4H TO ,F8.3,9X,I4,6X,F10.1)
  520 FORMAT (1H0,19X,100I1)
  530 FORMAT (11X,100I1)
  540 FORMAT(1H1,T25,20A4//T25,20A4/)  
  550 FORMAT (25X,20A4/)
  560 FORMAT (1H+,A1)  
  570 FORMAT (1H+,10X,2A4) 
  580 FORMAT (1H+,T65,3E20.8)  
  590 FORMAT (/T60,'TOTAL',3E20.8) 
  600 FORMAT (//)  
  610 FORMAT (1H+,T70,'AREA',1X,A6,'**2',T89,'VOLUME',1X,A6,'**3', 
     1T109,'VOLUME',1X,A6,'**3'/T89,'SATURATED',T109,'PRESSURE')
  620 FORMAT (1H ,I5,4X,1H.,100A1) 
  630 FORMAT (1H ,3X,A1,8X,F8.3,4H TO ,F8.3,9X,I4,6X,F10.1)
  640 FORMAT (1H0,19X,100I1)
  650 FORMAT (10X,1H.,100I1)
  660 FORMAT (11X,100A1)
  670 FORMAT (10X,2A4) 
  680 FORMAT (T5,'ROW')
  690 FORMAT (' SCALE INCORRECT  PLOT TERMINATED'//)
      END  
